- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# ecs_ecr – Manage Elastic Container Registry repositories

- Synopsis

- Requirements

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- Manage Elastic Container Registry repositories

## Requirements

The below requirements are needed on the host that executes this module.

- boto

- boto3

- python >= 2.6

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
aws_access_key string |  | AWS access key. If not set then the value of the AWS_ACCESS_KEY_ID, AWS_ACCESS_KEY or EC2_ACCESS_KEY environment variable is used. aliases: ec2_access_key, access_key
aws_secret_key string |  | AWS secret key. If not set then the value of the AWS_SECRET_ACCESS_KEY, AWS_SECRET_KEY, or EC2_SECRET_KEY environment variable is used. aliases: ec2_secret_key, secret_key
debug_botocore_endpoint_logs boolean added in 2.8 | Choices: no ← yes | Use a botocore.endpoint logger to parse the unique (rather than total) "resource:action" API calls made during a task, outputing the set to the resource_actions key in the task results. Use the aws_resource_action callback to output to total list made during a playbook. The ANSIBLE_DEBUG_BOTOCORE_LOGS environment variable may also be used.
delete_policy boolean | Choices: no ← yes | if yes, remove the policy from the repository
ec2_url string |  | Url to use to connect to EC2 or your Eucalyptus cloud (by default the module will use EC2 endpoints). Ignored for modules where region is required. Must be specified for all other modules if region is not used. If not set then the value of the EC2_URL environment variable, if any, is used.
force_set_policy boolean | Choices: no ← yes | if no, prevents setting a policy that would prevent you from setting another policy in the future.
name - / required |  | the name of the repository
policy - |  | JSON or dict that represents the new policy
profile string |  | Uses a boto profile. Only works with boto >= 2.24.0.
region string |  | The AWS region to use. If not specified then the value of the AWS_REGION or EC2_REGION environment variable, if any, is used. See http://docs.aws.amazon.com/general/latest/gr/rande.html#ec2_region aliases: aws_region, ec2_region
registry_id - |  | AWS account id associated with the registry. If not specified, the default registry is assumed.
security_token string |  | AWS STS security token. If not set then the value of the AWS_SECURITY_TOKEN or EC2_SECURITY_TOKEN environment variable is used. aliases: access_token
state - | Choices: present ← absent | create or destroy the repository
validate_certs boolean | Choices: no yes ← | When set to "no", SSL certificates will not be validated for boto versions >= 2.6.0.

## Notes

Note

- If parameters are not set within the module, the following environment variables can be used in decreasing order of precedence `AWS_URL` or `EC2_URL`, `AWS_ACCESS_KEY_ID` or `AWS_ACCESS_KEY` or `EC2_ACCESS_KEY`, `AWS_SECRET_ACCESS_KEY` or `AWS_SECRET_KEY` or `EC2_SECRET_KEY`, `AWS_SECURITY_TOKEN` or `EC2_SECURITY_TOKEN`, `AWS_REGION` or `EC2_REGION`

- Ansible uses the boto configuration file (typically ~/.boto) if no credentials are provided. See https://boto.readthedocs.io/en/latest/boto_config_tut.html

- `AWS_REGION` or `EC2_REGION` can be typically be used to specify the AWS region, when required, but this can also be configured in the boto config file

## Examples

    # If the repository does not exist, it is created. If it does exist, would not
    # affect any policies already on it.
    - name: ecr-repo
      ecs_ecr: name=super/cool

    - name: destroy-ecr-repo
      ecs_ecr: name=old/busted state=absent

    - name: Cross account ecr-repo
      ecs_ecr: registry_id=999999999999 name=cross/account

    - name: set-policy as object
      ecs_ecr:
        name: needs-policy-object
        policy:
          Version: '2008-10-17'
          Statement:
            - Sid: read-only
              Effect: Allow
              Principal:
                AWS: '{{ read_only_arn }}'
              Action:
                - ecr:GetDownloadUrlForLayer
                - ecr:BatchGetImage
                - ecr:BatchCheckLayerAvailability

    - name: set-policy as string
      ecs_ecr:
        name: needs-policy-string
        policy: "{{ lookup('template', 'policy.json.j2') }}"

    - name: delete-policy
      ecs_ecr:
        name: needs-no-policy
        delete_policy: yes

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
created boolean | always | If true, the repository was created
name string | when state == 'absent' | The name of the repository
repository dictionary | when state == 'present' | The created or updated repository Sample: {'createdAt': '2017-01-17T08:41:32-06:00', 'registryId': '999999999999', 'repositoryArn': 'arn:aws:ecr:us-east-1:999999999999:repository/ecr-test-1484664090', 'repositoryName': 'ecr-test-1484664090', 'repositoryUri': '999999999999.dkr.ecr.us-east-1.amazonaws.com/ecr-test-1484664090'}
state string | always | The asserted state of the repository (present, absent)

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Community. [community]

### Authors

- David M. Lee (@leedm777)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.